VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3690
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7950
   LinkTopic       =   "Form1"
   ScaleHeight     =   3690
   ScaleWidth      =   7950
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command6 
      Caption         =   "Command6"
      Height          =   510
      Left            =   135
      TabIndex        =   6
      Top             =   2970
      Width           =   1635
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Print Methods"
      Height          =   375
      Left            =   6075
      TabIndex        =   5
      Top             =   2880
      Width           =   1590
   End
   Begin VB.CommandButton Command4 
      Caption         =   "ShowVariantType"
      Height          =   420
      Left            =   6120
      TabIndex        =   4
      Top             =   2295
      Width           =   1590
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Read Array"
      Height          =   420
      Left            =   6210
      TabIndex        =   3
      Top             =   1620
      Width           =   1365
   End
   Begin VB.ListBox List1 
      Height          =   2595
      Left            =   180
      TabIndex        =   2
      Top             =   180
      Width           =   5775
   End
   Begin VB.CommandButton Command2 
      Caption         =   "GetVarArray"
      Height          =   465
      Left            =   6165
      TabIndex        =   1
      Top             =   945
      Width           =   1410
   End
   Begin VB.CommandButton Command1 
      Caption         =   "MSDN Samples"
      Height          =   510
      Left            =   6165
      TabIndex        =   0
      Top             =   180
      Width           =   1410
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'long __stdcall AddLongs_Pointer(long *plArrayOfLongs, long lElements)
Private Declare Function AddLongs_Pointer Lib "safe_array.dll" _
   (FirstElement As Long, ByVal lElements As Long) As Long

'int __stdcall AddLongs_SafeArray(SAFEARRAY **psaArray, long *plSum)
Private Declare Function AddLongs_SafeArray Lib "safe_array.dll" _
   (ary() As Long, lSum As Long) As Long

'int __stdcall GetVariantArray(int newVal, VARIANT *pVal)
Private Declare Function GetVariantArray Lib "safe_array.dll" _
   (ByVal newVal As Long, ByRef v As Variant) As Long

'int __stdcall ReadArray(VARIANT *pVal)
Private Declare Function ReadArray Lib "safe_array.dll" (ByRef v As Variant) As Long

'int __stdcall ShowVariantType(VARIANT *pVal, char* buf, int bufSz)
Private Declare Function ShowVariantType Lib "safe_array.dll" (ByRef v As Variant, ByRef buf As Byte, ByVal sz As Long) As Long

'following three are equilivent..
'Private Declare Sub PrintMethods Lib "safe_array.dll" (ByVal obj As Long) 'objptr(me)
'Private Declare Sub PrintMethods Lib "safe_array.dll" (ByVal obj As Object) 'me
Private Declare Sub PrintMethods Lib "safe_array.dll" (ByVal obj As IUnknown) 'me

'void __stdcall ReadBstr(BSTR* b)
Private Declare Sub ReadBstr Lib "safe_array.dll" (ByVal vPtr As Long, Optional ByVal showMsgbox As Long = 0) 'this works with varPtr(string), avoids auto translation to C string by runtime...

Private Declare Function LoadLibrary Lib "kernel32" Alias _
    "LoadLibraryA" (ByVal lpLibFileName As String) As Long

Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long


Dim hLib As Long

Property Let aaaa(v As Long)

End Property

Property Get aaaa() As Long

End Property

Public Function testing()
    MsgBox 1
End Function

Private Sub Command1_Click()
      Dim ArrayOfLongs(2) As Long
      Dim lSum As Long
      Dim k As Long

      ArrayOfLongs(0) = 1
      ArrayOfLongs(1) = 2
      ArrayOfLongs(2) = 3

      lSum = AddLongs_Pointer(ArrayOfLongs(0), UBound(ArrayOfLongs) + 1)
      MsgBox "Result with C array = " & Str$(lSum)

      k = AddLongs_SafeArray(ArrayOfLongs(), lSum)
      If k = 0 Then
         MsgBox "Result with Safearray = " & Str$(lSum)
      Else
         MsgBox "Call with Safearray failed"
      End If
      
End Sub

Private Sub Command2_Click()
    Dim rv As Long, v As Variant
    List1.Clear
    rv = GetVariantArray(5, v)
    With List1
        .AddItem "TypeName(v) = " & TypeName(v)
        .AddItem "ubound(v) = " & UBound(v)
        For i = LBound(v) To UBound(v)
            .AddItem "v(" & i & ") = " & v(i) & " -- " & TypeName(v(i))
        Next
    End With
    
End Sub

Private Sub Command3_Click()
    Dim v As Variant
    Dim tmp() As Variant
    
    ReDim tmp(8)
    
    tmp(0) = "test"
    tmp(1) = CByte(1)
    tmp(2) = "ing"
    tmp(3) = 2
    Set tmp(4) = Me
    tmp(5) = 3.1416
    tmp(6) = CByte(255)
    tmp(7) = CDbl(123456)
    tmp(8) = CCur(123456)
    'tmp(8) = CCur(12345678999#) '<--this one will cause a crash...
    
    ReadArray tmp                           'VT_ARRAY | VT_VARIANT | VT_BYREF
    ReadArray Array(1, "two", 3, "four")    'VT_ARRAY | VT_VARIANT
    
End Sub

Private Sub Command4_Click()
    Dim tmp(2) As Variant
    Dim l(2) As Long
    Dim v As Variant
    Dim e As Variant
    
    v = "test"
    
    List1.Clear
    List1.AddItem "tmp(2) As Variant = " & HumanReadableVarFlags(tmp)
    List1.AddItem "Array(1, 2, 3) = " & HumanReadableVarFlags(Array(1, 2, 3))
    List1.AddItem "l(2) As Long = " & HumanReadableVarFlags(l)
    List1.AddItem "v As Variant = test = " & HumanReadableVarFlags(v)
    List1.AddItem "e As Variant (unset) = " & HumanReadableVarFlags(e)
    List1.AddItem "CLng(1) = " & HumanReadableVarFlags(CLng(1))
    List1.AddItem "me = " & HumanReadableVarFlags(Me)

End Sub

Private Function HumanReadableVarFlags(v As Variant) As String
    Dim b() As Byte
    ReDim b(500)
    Dim sz As Long
    Dim ret As String
    
    sz = ShowVariantType(v, b(0), UBound(b) - 1)
    ret = StrConv(b, vbUnicode)
    ret = Left(ret, sz)
    If Right(ret, 1) = Chr(0) Then MsgBox 1
    
    HumanReadableVarFlags = ret
    
End Function
    

Private Sub Command5_Click()
 
    Set c = CreateObject("Scripting.FileSystemObject")
    PrintMethods c
    
    'has to be a published activex interface. this sometimes works in the IDE
    'but never in teh compiled exe..
    'PrintMethods ObjPtr(Me)
    
End Sub

Private Sub Command6_Click()
    Dim myString As String
    
    'testing for memory leaks...nope no leaks..
    For i = 0 To 10000
        myString = "testing!"
        ReadBstr VarPtr(myString)
    Next
    
    MsgBox "Final string: " & myString
    
End Sub

Private Sub Form_Load()

    'this also works to explicitly set the path to load the dll from..
    ChDir App.Path '& "\whatever"
    

End Sub

Private Sub Form_Unload(Cancel As Integer)
    'and this is so the IDE doesnt hang onto it and we can recompile without closing ide..
    hLib = GetModuleHandle("safe_array.dll")
    FreeLibrary hLib
End Sub
